//To use this widget from an html file in your root add 
// dojo.registerModulePath("@zwPackage@", "../zwidgets/@zwPackageDir@");
//to your html file's script tag.
//To use this widget from an html file located elsewhere add the relative path 
//to your root before resources (above).

dojo.provide("@zwPackage@.@name@");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojo.i18n");
dojo.require("dojo.string");
//The default message file for this widget is located in: app/zwidgets/@zwPackageDir@/nls/@name@.js
dojo.requireLocalization("@zwPackage@", "@name@");

dojo.declare(
    "@zwPackage@.@name@",
    [
		dijit._Widget,
		dijit._Widget,dijit._Templated
	],
	{
		//The template file for this widget is located in: app/zwidgets/@zwPackageDir@/templates/@name@.html		
		templatePath: dojo.moduleUrl("@zwPackage@","templates/@name@.html"),
		widgetsInTemplate: true,
		messages: {},
		
		postMixInProperties: function() {
			//If you provide a postMixInProperties method for your 
			//widget, it will be invoked before rendering occurs, 
			//and before any dom nodes are created. If you need to 
			//add or change the instance's properties before the 
			//widget is rendered - this is the place to do it.
			this.messages = dojo.i18n.getLocalization("@zwPackage@", "@name@"); 			
			this.inherited("postMixInProperties", arguments);
		},
		
		buildRendering: function() {
			//_Templated provides an implementation of buildRendering 
			//that most times will do what you need. The template is 
			//fetched/read, nodes created and events hooked up during
			//buildRendering. 
			this.inherited("buildRendering", arguments);
		},
		
		postCreate: function() {
			//This is typically the workhorse of a custom widget. The 
			//widget has been rendered (but note that sub-widgets in 
			//the containerNode have not!) 
			this.inherited("postCreate", arguments);			
		},
		
		startup: function() {
			//If you need to be sure parsing and creation of any child 
			//widgets is complete, use startup. 
			this.inherited("startup", arguments);			
		},

		destroy: function() {
			//Implement destroy if you have special tear-down work to 
			//do (the superclasses will take care of most of it for you)
			this.inherited("destroy", arguments);			
		}
		
	}
);
